/* CHIRP '09, (c) 2008-2009 Kit S. Goncharov/Ampersand Software. The source code and graphics are distributed under a Creative Commons Attribution-Share Alike 3.0 License (http://creativecommons.org/licenses/by-sa/3.0).

The Base64() function is based on base64.js, (c) 2007 David Lindquist (http://stringify.com/2007/jun/18/base64). The Prototype Methods (evalJSON, each, bind, createClass, $, $w, Template, and Ajax) are based on the Prototype framework, (c) 2005-2008 Sam Stephenson (http://prototypejs.org).
	
We hope you enjoy using Chirp '09! Visit us on the web at http://ampsw.com/Chirp. */
var Chirp = {}, Yes = true, No = false;
window.onload = function(){
	Chirp.infoButton = new AppleInfoButton($("infoButton"), $("main"), "white", "white", showPrefs);
	Chirp.scrollArea = new AppleScrollArea($("box"), new AppleVerticalScrollbar($("scroller")));
	Chirp.doneButton = new AppleGlassButton($("done"), "Done", hidePrefs);
	Chirp.version = "6.0";
	Chirp.twitterAPI = "https://twitter.com/";
	Chirp.ffAPI = "http://friendfeed.com/api/";
	Chirp.idAPI = "http://identi.ca/api/";
	Chirp.onBack = No;
	widget.onhide = function(){
		clearTimers();
	};
	widget.onshow = function(){
		if(!Chirp.onBack){
			Chirp.Get();
		}
	};
	widget.onremove = function(){
		clearTimers();
		Object.each($w('background username password service feed cache'), function(s){
			$p(s, null);
		});
	};
	loadPrefs();
	checkUpdate();
};
function loadPrefs(){
	var username = $p("username"), password = $p("password"), service = $p("service"), feed = $p("feed"), color = $p("background");
	if(!username || !password){
		showPrefs();
		Chirp.doneButton.setEnabled(No);
	}else{
		Chirp.Get();
		$("username").value = username;
		$("password").value = password;
	}

	if(color){
		$("colors").selectedIndex = color;
		setColor();
	}else{
		$("main").className = "cacao";
		$p("background", "0");
	} (feed ? $("feed").selectedIndex = feed: $p("feed", "0")); (service ? $("service").selectedIndex = service: $p("service", "0"));

	updateFeeds();
}
function setFeed(){
	var sel = $("feed");
	switch(parseInt(sel.options[sel.selectedIndex].value, 10)){
	case 1:
		$p("feed", "0");
		break;
	case 2:
		$p("feed", "1");
		break;
	case 3:
		$p("feed", "2");
		break;
	case 4:
		$p("feed", "3");
		break;
	case 5:
		$p("feed", "4");
		break;
	case 6:
		$p("feed", "5");
		break;
	case 7:
		$p("feed", "6");
		break;
	}
}
function setService(){
	var sel = $("service");
	switch(parseInt(sel.options[sel.selectedIndex].value, 10)){
	case 1:
		$p("service", "0");
		break;
	case 2:
		$p("service", "1");
		break;
	case 3:
		$p("service", "2");
		break;
	case 4:
		$p("service", "3");
		break;
	}
	updateFeeds();
}
function setColor(){
	var sel = $("colors");
	switch(parseInt(sel.options[sel.selectedIndex].value, 10)){
	case 1:
		$p("background", "0");
		$("main").className = "cacao";
		break;
	case 2:
		$p("background", "1");
		$("main").className = "ruby";
		break;
	case 3:
		$p("background", "2");
		$("main").className = "night";
		break;
	case 4:
		$p("background", "3");
		$("main").className = "pine";
		break;
	case 5:
		$p("background", "4");
		$("main").className = "chrome";
		break;
	case 6:
		$p("background", "5");
		$("main").className = "shadow";
		break;
	}
}
function updateFeeds(){
	var service = $p("service"), feed = $("feed"), list = feed.options;
	if(service == "0"){
		list[0].text = "Friends Timeline";
		list[1].text = "Public Timeline";
		list[2].text = "My Tweets Only"; (list[3] ? list[3].text = "@ Replies": list[3] = new Option("@ Replies", "4")); (list[4] ? list[4].text = "Direct Messages": list[4] = new Option("Direct Messages", "5"));
		list.length = 5;
		$('label', 'Password:&nbsp;');
		$$.chars.on();
	}else if(service == "1"){
		list[0].text = "Overview";
		list[1].text = "Public Stream";
		list[2].text = "My Stream";
		list.length = 3;
		$('label', "<a onclick=\"$URL(\'http://api.jaiku.com/key\')\">API Key:</a>&nbsp;");
		$$.chars.on();
	}else if(service == "2"){
		list[0].text = "Friends Feed";
		list[1].text = "Public Feed";
		list[2].text = "Rooms Feed"; (list[3] ? list[3].text = "My Feed": list[3] = new Option("My Feed", "4"));
		list.length = 4;
		$('label', "<a onclick=\"$URL(\'http://friendfeed.com/remotekey\')\">Remote Key:</a>&nbsp;");
		$$.chars.off();
	}else if(service == "3"){
		list[0].text = "Friends Stream";
		list[1].text = "Public Stream";
		list[2].text = "My Notices Only"; (list[3] ? list[3].text = "Replies": list[3] = new Option("Replies", "4")); (list[4] ? list[4].text = "Inbox": list[4] = new Option("Inbox", "5"));
		list.length = 5;
		$('label', 'Password:&nbsp;');
		$$.chars.on();
	}
	$('srv', Service.name());
}
function saveInfo(e){
	var uid = $('username').value, pwd = $('password').value;
	if(uid && pwd){
		if(e){
			$p('username', uid);
			$p('password', pwd);
		}
		Chirp.doneButton.setEnabled(Yes);
	}else{
		if(e){
			$p('username', null);
			$p('password', null);
		}
		Chirp.doneButton.setEnabled(No);
	}
}
function Base64(str){
	var set = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=', z = "", a = 0;
	while(a < str.length){
		var b = str.charCodeAt(a++),
		c = str.charCodeAt(a++),
		d = str.charCodeAt(a++),
		buf = (b << 16) + ((c || 0) << 8) + (d || 0),
		e = (buf & (63 << 18)) >> 18,
		f = (buf & (63 << 12)) >> 12,
		g = isNaN(c) ? 64 : (buf & (63 << 6)) >> 6,
		h = isNaN(d) ? 64 : (buf & 63);
		z += set.charAt(e) + set.charAt(f) + set.charAt(g) + set.charAt(h);
	}
	return z;
}
var $$ = {
	chars: {
		_att: $w('keydown keyup blur focus paste'),
		_count: function(){
			var text = $('update'); (text.value.length > 140 ? text.value = text.value.substring(0, 140) : $("chars").value = 140 - text.value.length);
		},
		on: function(){
			Object.each(this._att, function(s){
				$('update')['on' + s] = this._count;
			}.bind(this));
			$$.show('chars');
		},
		off: function(){
			Object.each(this._att, function(s){
				$('update')['on' + s] = null;
			});
			$$.hide('chars');
		}
	},
	scroll: function(){
		Chirp.scrollArea.refresh();
	},
	hide: function(s){
		$(s).style.display = 'none';
	},
	show: function(s){
		$(s).style.display = 'block';
	},
	box: {
		hide: function(){
			$$.hide('to');
			$('update').style.height = '67.5px';
		},
		show: function(t){
			$$.show('to');
			$('update').style.height = '46px';
			$('to').setAttribute('placeholder', t);
		}
	},
	inject: function(t){
		$('twitters', t);
	}

};
Array.prototype.add = function(){
	Object.each(arguments, function(s){
		this[this.length] = s;
	}.bind(this));
};
//PROTOTYPE METHODS
function createClass(){
	return function(){
		this.$init.apply(this, arguments);
	};
}
var Template = createClass();
Template.prototype = {
	$init: function(template){
		this.template = template.toString();
	},
	exec: function(obj){
		var r = '', m, p = /(^|.|\r|\n)(#\{(.*?)\})/, s = this.template,
		fx = function(m){
			var before = m[1];
			if(before == '\\'){
				return m[2];
			}
			return before + (obj[m[3]] ? obj[m[3]] : '');
		};
		while(s.length > 0){
			m = s.match(p);
			if(m){
				r += s.slice(0, m.index);
				r += (fx(m) ? fx(m) : '');
				s = s.slice(m.index + m[0].length);
			}else{
				r += s;
				s = '';
			}
		}
		return r;
	}
};
Function.prototype.bind = function(obj){
	var __method = this;
	return function(){
		return __method.apply(obj, arguments);
	};
};
Object.each = function(obj, fn, k){
	for(var i = k || 0, j = obj.length; i < j; ++i){
		fn(obj[i]);
	}
};
String.prototype.evalJSON = function(){
	if(this.length < 1){
		return null;
	}
	try{
		if((/^[,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t]*$/).test(this.replace(/\\./g, '@').replace(/"[^"\\\n\r]*"/g, ''))){
			return eval('(' + this + ')');
		}
	}catch(e){}
	throw new Error();
};
var Ajax = createClass();
Ajax.num = 1;
Ajax.Events = $w('Uninitialized Loading Loaded Interactive Complete');
Ajax.emptyFx = function(){};
Ajax.prototype = {
	$init: function(url, options){
		this.xhr = new XMLHttpRequest();
		this.options = options;
		this.send = options.send || '';
		this.method = options.method || 'get';
		this.auth = options.auth || '';
		this.args = options.args || '';
		this.timeout = (options.timeout * 1000) || 15000;
		this.onTimeout = options.onTimeout || function(){
			return $EX(Chirp.timeError);
		};
		this.request(url);
	},
	request: function(url){
		Ajax.num++;
		if(this.method == 'get'){
			url += (url.indexOf("?") == -1 ? "?": "&") + "_=" + Ajax.num;
		}
		this.xhr.open(this.method, url, Yes);
		this.xhr.onreadystatechange = this.onStateChange.bind(this);
		setTimeout((function(){
			this.respondToReadyState(1);
		}).bind(this), 10);
		this.setHeaders();
		this.xhr.send(this.send);
		this.startTimer();
	},
	setHeaders: function(){
		var headers = ['X-Chirp-Version', Chirp.version];
		if(this.method == 'post'){
			headers.add('Cache-Control', 'no-cache', 'Content-Type', 'application/x-www-form-urlencoded', 'Connection', 'close');
		}
		if(this.auth){
			headers.add('Authorization', 'Basic ' + Base64(this.auth.uid + ':' + this.auth.pwd));
		}
		for(var i = 0, j = headers.length; i < j; i += 2){
			this.xhr.setRequestHeader(headers[i], headers[i+1]);
		}
	},
	onStateChange: function(){
		var readyState = this.xhr.readyState;
		if(readyState != 1){
			this.respondToReadyState(this.xhr.readyState);
		}
	},
	respondToReadyState: function(readyState){
		var event = Ajax.Events[readyState];
		if(event == 'Complete'){
			this.clearTimer(); (this.options['on' + (this.xhr.status || 0)] || this.options['on' + (this.responseIsSuccess() ? 'Success': 'Failure')] || Ajax.emptyFx)(this.xhr, this.args);
		} (this.options['on' + event] || Ajax.emptyFx)(this.xhr, this.args);
		if(event == 'Complete'){
			this.xhr.onreadystatechange = Ajax.emptyFx;
		}
	},
	responseIsSuccess: function(){
		return (this.xhr.status >= 200 && this.xhr.status < 300) || this.xhr.status == 304;
	},
	responseIsFailure: function(){
		return !this.responseIsSuccess();
	},
	clearTimer: function(){
		clearTimeout(this.timer);
		this.timer = null;
	},
	startTimer: function(){
		this.timer = setTimeout((function(){
			this.destroy();
			this.onTimeout();
		}).bind(this), this.timeout);
	},
	destroy: function(){
		this.xhr.abort();
		this.xhr.onreadystatechange = Ajax.emptyFx;
		this.clearTimer();
	}
};
function $w(str){
	return str ? str.split(/\s+/) : [];
}
function $(el){
	if(arguments.length > 1){
		document.getElementById(el).innerHTML = arguments[1];
	}else{
		return document.getElementById(el);
	}
}
function checkUpdate(){
	Chirp.Midnight = new Ajax('http://ampsw.com/Chirp/update.xml', {
		onSuccess: function(xhr){
			if(xhr.responseXML){
				var xml = xhr.responseXML.documentElement,
				version = xml.getElementsByTagName("Version")[0].firstChild.data,
				url = xml.getElementsByTagName("URL")[0].firstChild.data;
				if(Chirp.version < version){
					(new AppleGlassButton($("updateButton"), "Update to v" + version, function(){
						$URL(url);
					}));
					$$.show('updateButton');
				}
			}else{
				return;
			}
		},
		onTimeout: Ajax.emptyFx,
		timeout: 7.5,
		onFailure: Ajax.emptyFx
	});
}
function clearTimers(){
	if(Chirp.Req){
		Chirp.Req.destroy();
		Chirp.Req = null;
	}
	if(Chirp.postReq){
		Chirp.postReq.destroy();
		Chirp.postReq = null;
	}
	if(Chirp.Midnight){
		Chirp.Midnight.destroy();
		Chirp.Midnight = null;
	}
	$$.hide('loader');
}
var Service = {
	feed: function(){
		var arr = $w('timeline stream feed stream');
		return arr[$p("service")];
	},
	name: function(){
		var arr = $w('Twitter Jaiku FriendFeed Identi.ca');
		return arr[$p("service")];
	},
	post: function(){
		var arr = $w('tweet Jaiku message notice');
		return arr[$p("service")];
	}
};
function showPrefs(){
	flip("back", "main", "ToBack",
	function(){
		Chirp.onBack = Yes;
		clearTimers();
	});
}
function hidePrefs(){
	flip("main", "back", "ToFront",
	function(){
		Chirp.onBack = No;
		saveInfo(Yes);
		Chirp.Get();
	});
}
function flip(show, hide, trans, fx){
	widget.prepareForTransition(trans);
	fx();
	$$.hide(hide);
	$$.show(show);
	setTimeout('widget.performTransition();', 0);
}
function search(){
	var val = $("search").value, term = val.replace(/([.*+?^=!:${}()|[\]\/\\])/g, "\\$1"), results = "", regExp = new RegExp(term, "i");
	if(!Chirp.arr || Chirp.arr.length < 1){
		return $EX("Chirp hasn't downloaded any " + Service.post() + "s yet! Please allow Chirp to connect and then try searching again.");
	}else{
		Object.each(Chirp.arr, function(s){
			if(!term || s.replace(/<\/?[^>]+>/gi, '').match(regExp)){
				results += s;
			}
		});
		if(!results || results.length < 1){
			return $EX("No " + Service.post() + "s were found containing '" + val + "'. Please try your search again.", Yes);
		}else{
			$$.inject('<table><tbody>' + results + '</tbody></table>');
		}
		$$.scroll();
	}
}
function $p(){
	if(arguments.length > 1){
		widget.setPreferenceForKey(arguments[1], createKey(arguments[0]));
	}else{
		return widget.preferenceForKey(createKey(arguments[0]));
	}
}
function createKey(val){
	return val + '.' + widget.identifier;
}
function $URL(url){
	widget.openURL(url);
}
function $EX(error, cache){
	clearTimers();
	var err = API.errorTemplate.exec(arguments);
	var cjson = $p("cache");
	if(cjson && !cache){
		try{
			var json = cjson.evalJSON();
			Chirp.arr = ['<tr><td><img src="Icon.png" class="avatar" width="36" height="36" alt="Chirp"><span class="item"><strong>Chirp last successfully connected to ' + json[0].last + ' ' + API.time(json[0].when) + '. This is Chirp\'s cache of your ' + json[0].type + ' as it appeared then.</strong></span></td></tr>'];
			Object.each(json, function(s){
				Chirp.arr.add('<tr><td><span class="item"><strong>' + decodeURIComponent(s.name) + '</strong>: ' + API.links(decodeURIComponent(s.post)) + '<strong><em> ' + API.time(s.time) + '</a></em></span></td></tr>');
			}, 1);
			$$.inject('<table><tbody>' + err + Chirp.arr.join('') + '</tbody></table>');
		}catch(e){
			$p("cache", null);
			return $EX(error, Yes);
		}
	}else{
		$$.inject('<table><tbody>' + err + '</tbody></table>');
	}
	$$.scroll();
}
//API METHODS
Chirp.Get = function(){
	if(Chirp.Req){
		Chirp.Req.destroy();
		Chirp.Req = null;
	}
	$$.show('loader');
	$("search").value = '';
	var username = $p("username"), password = $p("password"), feed = $p("feed"), service = $p("service");
	if((service == "0" || service == "3") && (username && password)){
		var api = (service == '0' ? Chirp.twitterAPI: Chirp.idAPI);
		$$.box.hide();
		if(feed == "0"){
			Chirp.Req = new Ajax(api + 'statuses/friends_timeline.json', {
				auth: {uid: username, pwd: password},
				onSuccess: Parse.Twitter,
				on400: function(){return $EX(Service.name() + " returned a 'bad request' error. This usually happens when you exceed your hourly refresh rate limit. To avoid this, make sure that you aren't running too many " + Service.name() + " programs at once or refreshing your " + Service.feed() + " too frequently.");},
				on500: function(){return $EX(Service.name() + " returned an 'internal server' error. This is a problem with the server, so please try refreshing again in a few minutes.");},
				on502: function(){return $EX(Service.name() + " returned a 'bad gateway' error. This usually happens when " + Service.name() + " is down or being upgraded. Please try again in a few minutes...");},
				on503: function(){return $EX(Service.name() + " is temporarily overloaded. Please check back in a few minutes...");},
				on0: function(){return $EX(Chirp.noInternet);},
				onFailure: function(){return $EX(Chirp.failure);},
				args: 'timeline'
			});
		}else if(feed == "1"){
			Chirp.Req = new Ajax(api + 'statuses/public_timeline.json', {
				onSuccess: Parse.Twitter,
				on400: function(){return $EX(Service.name() + " returned a 'bad request' error. This usually happens when you exceed your hourly refresh rate limit. To avoid this, make sure that you aren't running too many " + Service.name() + " programs at once or refreshing your " + Service.feed() + " too frequently.");},
				on500: function(){return $EX(Service.name() + " returned an 'internal server' error. This is a problem with the server, so please try refreshing again in a few minutes.");},
				on502: function(){return $EX(Service.name() + " returned a 'bad gateway' error. This usually happens when " + Service.name() + " is down or being upgraded. Please try again in a few minutes...");},
				on503: function(){return $EX(Service.name() + " is temporarily overloaded. Please check back in a few minutes...");},
				on0: function(){return $EX(Chirp.noInternet);},
				onFailure: function(){return $EX(Chirp.failure);},
				args: 'timeline'
			});
		}else if(feed == "2"){
			Chirp.Req = new Ajax(api + 'statuses/user_timeline.json', {
				auth: {uid: username, pwd: password},
				onSuccess: Parse.Twitter,
				on400: function(){return $EX(Service.name() + " returned a 'bad request' error. This usually happens when you exceed your hourly refresh rate limit. To avoid this, make sure that you aren't running too many " + Service.name() + " programs at once or refreshing your " + Service.feed() + " too frequently.");},
				on500: function(){return $EX(Service.name() + " returned an 'internal server' error. This is a problem with the server, so please try refreshing again in a few minutes.");},
				on502: function(){return $EX(Service.name() + " returned a 'bad gateway' error. This usually happens when " + Service.name() + " is down or being upgraded. Please try again in a few minutes...");},
				on503: function(){return $EX(Service.name() + " is temporarily overloaded. Please check back in a few minutes...");},
				on0: function(){return $EX(Chirp.noInternet);},
				onFailure: function(){return $EX(Chirp.failure);},
				args: 'timeline'
			});
		}else if(feed == "3"){
			Chirp.Req = new Ajax(api + 'statuses/replies.json', {
				auth: {uid: username, pwd: password},
				onSuccess: Parse.Twitter,
				on400: function(){return $EX(Service.name() + " returned a 'bad request' error. This usually happens when you exceed your hourly refresh rate limit. To avoid this, make sure that you aren't running too many " + Service.name() + " programs at once or refreshing your " + Service.feed() + " too frequently.");},
				on500: function(){return $EX(Service.name() + " returned an 'internal server' error. This is a problem with the server, so please try refreshing again in a few minutes.");},
				on502: function(){return $EX(Service.name() + " returned a 'bad gateway' error. This usually happens when " + Service.name() + " is down or being upgraded. Please try again in a few minutes...");},
				on503: function(){return $EX(Service.name() + " is temporarily overloaded. Please check back in a few minutes...");},
				on0: function(){return $EX(Chirp.noInternet);},
				onFailure: function(){return $EX(Chirp.failure);},
				args: 'reply'
			});
		}else if(feed == "4"){
			Chirp.Req = new Ajax(api + 'direct_messages.json', {
				auth: {uid: username, pwd: password},
				onSuccess: Parse.DM,
				on400: function(){return $EX(Service.name() + " returned a 'bad request' error. This usually happens when you exceed your hourly refresh rate limit. To avoid this, make sure that you aren't running too many " + Service.name() + " programs at once or refreshing your " + Service.feed() + " too frequently.");},
				on500: function(){return $EX(Service.name() + " returned an 'internal server' error. This is a problem with the server, so please try refreshing again in a few minutes.");},
				on502: function(){return $EX(Service.name() + " returned a 'bad gateway' error. This usually happens when " + Service.name() + " is down or being upgraded. Please try again in a few minutes...");},
				on503: function(){return $EX(Service.name() + " is temporarily overloaded. Please check back in a few minutes...");},
				on0: function(){return $EX(Chirp.noInternet);},
				onFailure: function(){return $EX(Chirp.failure);}
			});
			$$.box.show('Send Direct Message To...');
		}
	}else if(service == "1" && (username && password)){
		$$.box.hide();
		if(feed == "0"){
			Chirp.Req = new Ajax('http://' + username + '.jaiku.com/contacts/feed/json?user=' + username + '&personal_key=' + password, {
				onSuccess: Parse.Jaiku,
				on0: function(){return $EX(Chirp.noInternet);},
				onFailure: function(){return $EX(Chirp.failure);}
			});
		}else if(feed == "1"){
			Chirp.Req = new Ajax('http://jaiku.com/feed/json', {
				onSuccess: Parse.Jaiku,
				on0: function(){return $EX(Chirp.noInternet);},
				onFailure: function(){return $EX(Chirp.failure);}
			});
		}else if(feed == "2"){
			Chirp.Req = new Ajax('http://' + username + '.jaiku.com/feed/json?user=' + username + '&personal_key=' + password, {
				onSuccess: Parse.Jaiku,
				on0: function(){return $EX(Chirp.noInternet);},
				onFailure: function(){return $EX(Chirp.failure);}
			});
		}
	}else if(service == "2" && (username && password)){
		$$.box.show('Link (Optional)');
		if(feed == "0"){
			Chirp.Req = new Ajax(Chirp.ffAPI + 'feed/home', {
				auth: {uid: username, pwd: password},
				onSuccess: Parse.FFeed,
				on0: function(){return $EX(Chirp.noInternet);},
				onFailure: function(){return $EX(Chirp.failure);},
				args: 'feed'
			});
		}else if(feed == "1"){
			Chirp.Req = new Ajax(Chirp.ffAPI + 'feed/public', {
				onSuccess: Parse.FFeed,
				on0: function(){return $EX(Chirp.noInternet);},
				onFailure: function(){return $EX(Chirp.failure);},
				args: 'feed'
			});
		}else if(feed == "2"){
			Chirp.Req = new Ajax(Chirp.ffAPI + 'feed/rooms', {
				auth: {uid: username, pwd: password},
				onSuccess: Parse.FFeed,
				on0: function(){return $EX(Chirp.noInternet);},
				onFailure: function(){return $EX(Chirp.failure);},
				args: 'rooms'
			});
		}else if(feed == "3"){
			Chirp.Req = new Ajax(Chirp.ffAPI + 'feed/user/' + username, {
				auth: {uid: username, pwd: password},
				onSuccess: Parse.FFeed,
				on0: function(){return $EX(Chirp.noInternet);},
				onFailure: function(){return $EX(Chirp.failure);},
				args: 'feed'
			});
		}
	}else if(!username || !password){
		return $EX("You must be signed in to see your " + Service.feed() + ".");
	}
};
Chirp.Post = function(){
	if(Chirp.postReq){
		Chirp.postReq.destroy();
		Chirp.postReq = null;
	}
	var username = $p("username"), password = $p("password"), service = $p("service"), feed = $p("feed");
	if((service == "0" || service == "3") && (username && password)){
		var api = (service == '0' ? Chirp.twitterAPI: Chirp.idAPI);
		if(feed != "4"){
			Chirp.postReq = new Ajax(api + 'statuses/update.json', {
				method: 'post',
				auth: {uid: username, pwd: password},
				send: 'status=' + encodeURIComponent($('update').value) + '&source=Chirp',
				onSuccess: function(){
					$("post").reset();
					Chirp.Get();
				},
				on0: function(){return $EX(Chirp.noInternet);},
				onFailure: function(){return $EX(Chirp.postError);}
			});
		}else{
			var to = $('to').value;
			if(!to){
				return $EX("You must provide a recipient for your message!");
			}else{
				Chirp.postReq = new Ajax(api + 'direct_messages/new.json', {
					method: 'post',
					auth: {uid: username, pwd: password},
					send: 'user=' + encodeURIComponent(to) + '&text=' + encodeURIComponent($('update').value) + '&source=chirp',
					onSuccess: function(){
						$("post").reset();
						Chirp.Get();
					},
					on403: function(){return $EX("Sorry! You can't send direct messages to users who aren't your friends.");},
					on0: function(){return $EX(Chirp.noInternet);},
					onFailure: function(){return $EX(Chirp.postError);}
				});
			}
		}
	}else if(service == "1" && (username && password)){
		Chirp.postReq = new Ajax('http://api.jaiku.com/json', {
			method: 'post',
			auth: {uid: username, pwd: password},
			send: 'user=' + encodeURIComponent(username) + '&personal_key=' + encodeURIComponent(password) + '&method=presence.send&message=' + encodeURIComponent($('update').value),
			onSuccess: function(){
				$("post").reset();
				Chirp.Get();
			},
			on0: function(){return $EX(Chirp.noInternet);},
			onFailure: function(){return $EX(Chirp.postError);}
		});
	}else if(service == "2" && (username && password)){
		var link = $('to').value;
		Chirp.postReq = new Ajax(Chirp.ffAPI + 'share', {
			method: 'post',
			auth: {uid: username, pwd: password},
			send: 'title=' + encodeURIComponent($('update').value) + (link ? '&link=' + encodeURIComponent(link) : ''),
			onSuccess: function(){
				$("post").reset();
				Chirp.Get();
			},
			on0: function(){return $EX(Chirp.noInternet);},
			onFailure: function(){return $EX(Chirp.postError);}
		});
	}else if(!username || !password){
		return $EX("You must be signed in to post " + Service.post() + "s.");
	}
};
//PARSING FUNCTIONS
var API = {
	now: function(){
		var a = (new Date()).toGMTString().split(' ');
		return ' ' + a[2] + ' ' + a[1] + ' ' + a[4] + ' +0000 ' + a[3];
	},
	URL: function(type, name, id){
		return type == "profile" ? $p("service") == "0" ? Chirp.twitterAPI + name: 'http://identi.ca/' + name: $p("service") == "0" ? Chirp.twitterAPI + name + '/statuses/' + id: 'http://identi.ca/notice/' + id;
	},
	fans: function(num){
		return $p("service") == "0" ? num == 1 ? num + ' Follower': num + ' Followers': num == 1 ? num + ' Subscriber': num + ' Subscribers';
	},
	links: function(text, rep){
		var urlExp = /((https?|s?ftp|ssh)\:\/\/[^"\s\<\>]*[^.,;'">\:\s\<\>\)\]\!])/gi,
		repExp = /\B@([_a-z0-9]+)/gi,
		srv = $p("service");
		return text.replace(urlExp, '<a onclick="$URL(\'$1\')">$1</a>').replace(repExp, (!rep) ? '@<strong><em>$1</em></strong>': '@<a onclick="$URL(\'' + (srv == "0" ? Chirp.twitterAPI + '$1': srv == 3 ? 'http://identi.ca/$1': 'http://$1.jaiku.com') + '\')">$1</a>');
	},
	reply: function(id, post){
		if(id){
			var test = /\B@([_a-z0-9]+)/gi.exec(post);
			if(!test){
				return '';
			}else{
				var user = test[0].split(" ")[0].slice(1);
				return user ? ' <a onclick="$URL(\'' + ($p("service") == "0" ? Chirp.twitterAPI + user + '/statuses/' + id: 'http://identi.ca/notice/' + id) + '\')">' + 'in reply to ' + user + '</a>': '';
			}
		}else{
			return '';
		}
	},
	setVal: function(to){
		$("to").value = to;
	},
	GMT: function(time, out){
		time = time.replace(/[A-Z]/gi, ' ');
		var date = time.split('-'),
		month = $w(' Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec'),
		day = date[2].split(' '),
		hour = day[1].split(' '),
		str = ' ' + month[parseInt(date[1], 10)] + ' ' + day[0] + ' ' + hour[0] + ' +0000 ' + date[0];
		return out ? str: this.time(str);
	},
	time: function(date){
		var vals = date.split(" ");
		date = vals[1] + " " + vals[2] + ", " + vals[5] + " " + vals[3];
		var ret = Date.parse(date),
		now = new Date(),
		when = parseInt((now.getTime() - ret) / 1000, 10);
		when = when + (now.getTimezoneOffset() * 60);
		var hr = (parseInt(when / 3600, 10)).toString(),
		dy = (parseInt(when / 86400, 10)).toString(),
		wk = (parseInt(when / 604800, 10)).toString(),
		mn = (parseInt(when / 2592000, 10)).toString(),
		yr = (parseInt(when / 31557600, 10)).toString();
		return when < 5 ? when <= 1 ? 'just now!': parseInt(when, 10).toString() + ' seconds ago': when < 120 ? '1 minute ago': when < (3600) ? (parseInt(when / 60, 10)).toString() + ' minutes ago': when < (86400) ? hr == 1 ? '1 hour ago': hr + ' hours ago': when < (604800) ? dy == 1 ? '1 day ago': dy + ' days ago': when < (2678400) ? wk == 1 ? '1 week ago': wk + ' weeks ago': when < (31557600) ? mn == 1 ? '1 month ago': mn + ' months ago': yr == 1 ? '1 year ago': yr + ' years ago';
	},
	avatarTemplate: new Template('<tr><td><img src="#{avatar}" class="avatar" width="36" height="36" title="#{user}" alt="#{user}\'s Avatar"><span class="item"><a#{name_link} onclick="$URL(\'#{url}\')">#{name}</a>: #{post}<em> <a onclick="$URL(\'#{link}\')">#{time}</a>#{reply_link}</em></span></td></tr>'),
	FFeedTemplate: new Template('<tr><td><span class="item"><a onclick="$URL(\'#{url}\')">#{name}</a>: #{post}<em> <a onclick="$URL(\'#{link}\')">#{time}</a> via <a onclick="$URL(\'#{via_url}\')">#{via}</a></em></span></td></tr>'),
	errorTemplate: new Template("<tr id='error'><td><span class='avatar'><img src='images/error.png' alt='Error'></span><span class='item'><strong>Error:</strong> #{0} <em><a onclick=\"$$.hide('error')\">hide</a></em></span></td></tr>"),
	cjsonTemplate: new Template('{"name":"#{name}","post":"#{post}","time":"#{time}"}'),
	cjsonHeader: new Template('{"last":"#{last}","type":"#{type}","when":"#{now}"}')
};
//PARSERS
var Parse = {
	Jaiku: function(xhr){
		$$.hide('loader');
		try{
			var json = xhr.responseText.evalJSON();
		}catch(e){
			return $EX('Jaiku returned a bad JSON response. This can occur if your username and API Key are incorrect. Please make sure that your username and key are correct and that you can connect to the Internet, then try refreshing again.');
		}
		if(!json || json.length < 1){
			return $EX("You haven't posted any Jaikus yet! To get started, type your new Jaiku in the box above.", Yes);
		}
		Chirp.arr = [];
		var cjson = [API.cjsonHeader.exec({
			last: 'Jaiku',
			type: 'stream',
			now: API.now()
		})];
		Object.each(json.stream, function(s){
			Chirp.arr.add(API.avatarTemplate.exec({
				avatar: s.user.avatar,
				user: s.user.nick,
				name: s.user.first_name + ' ' + s.user.last_name,
				url: s.user.url,
				post: API.links(s.title, Yes),
				link: s.url,
				time: API.GMT(s.created_at)
			}));
			cjson.add(API.cjsonTemplate.exec({
				name: encodeURIComponent(s.user.first_name + ' ' + s.user.last_name),
				post: encodeURIComponent(s.title),
				time: API.GMT(s.created_at, Yes)
			}));
		});
		var feed = Chirp.arr.join('');
		$$.inject('<table><tbody>' + feed + '</tbody></table>');
		$p("cache", '[' + cjson.toString() + ']');
		$$.scroll();
	},
	FFeed: function(xhr, type){
		$$.hide('loader');
		try{
			var json = xhr.responseText.evalJSON();
		}catch(e){
			return $EX(Chirp.jsonError);
		}
		if(!json || json.length < 1){
			if(type == "feed"){
				return $EX("You haven't posted any messages yet! To get started, type your new message in the box above.", Yes);
			}else if(type == "rooms"){
				return $EX("You haven't created any rooms yet! Click <a onclick=\"$URL('http://friendfeed.com/rooms/create')\">here</a> to create one.", Yes);
			}
		}
		Chirp.arr = [];
		var cjson = [API.cjsonHeader.exec({
			last: 'FriendFeed',
			type: 'entries',
			now: API.now()
		})];
		Object.each(json.entries, function(s){
			Chirp.arr.add(API.FFeedTemplate.exec({
				user: s.user.profileUrl,
				name: s.user.name,
				url: s.user.profileUrl,
				post: API.links(s.title),
				link: s.link,
				time: API.GMT(s.published),
				via: s.service.name,
				via_url: s.service.profileUrl
			}));
			cjson.add(API.cjsonTemplate.exec({
				name: encodeURIComponent(s.user.name),
				post: encodeURIComponent(s.title),
				time: API.GMT(s.published, Yes)
			}));
		});
		var feed = Chirp.arr.join('');
		$$.inject('<table><tbody>' + feed + '</tbody></table>');
		$p("cache", '[' + cjson.toString() + ']');
		$$.scroll();
	},
	Twitter: function(xhr, type){
		$$.hide('loader');
		try{
			var json = xhr.responseText.replace(/Couldn't find (Status|User) with ID=([0-9]*)/g, '').evalJSON();
		}catch(e){
			return $EX(Chirp.jsonError);
		}
		if(!json || json.length < 1){
			if(type == "timeline"){
				return $EX("You haven't posted any " + Service.post() + "s yet! To get started, tell us what you're doing in the box above.", Yes);
			}else if(type == 'reply'){
				return $EX("You haven't received any replies yet!", Yes);
			}
		}
		Chirp.arr = [];
		var cjson = [API.cjsonHeader.exec({
			last: Service.name(),
			type: Service.feed(),
			now: API.now()
		})];
		Object.each(json, function(s){
			Chirp.arr.add(API.avatarTemplate.exec({
				avatar: s.user.profile_image_url,
				user: s.user.screen_name,
				name: s.user.name,
				name_link: ' title="' + API.fans(s.user.followers_count) + '"',
				url: API.URL("profile", s.user.screen_name),
				post: API.links(s.text, Yes),
				link: API.URL("post", s.user.screen_name, s.id),
				time: API.time(s.created_at),
				reply_link: API.reply(s.in_reply_to_status_id, s.text)
			}));
			cjson.add(API.cjsonTemplate.exec({
				name: encodeURIComponent(s.user.name),
				post: encodeURIComponent(s.text),
				time: s.created_at
			}));
		});
		var feed = Chirp.arr.join('');
		$$.inject('<table><tbody>' + feed + '</tbody></table>');
		$p("cache", '[' + cjson.toString() + ']');
		$$.scroll();
	},
	DM: function(xhr){
		$$.hide('loader');
		try{
			var json = xhr.responseText.replace(/Couldn't find (Status|User) with ID=([0-9]*)/g, '').evalJSON();
		}catch(e){
			return $EX(Chirp.jsonError);
		}
		if(!json || json.length < 1){
			return $EX("You haven't received any direct messages yet!", Yes);
		}
		Chirp.arr = [];
		var cjson = [API.cjsonHeader.exec({
			last: Service.name(),
			type: 'direct message inbox',
			now: API.now()
		})];
		Object.each(json, function(s){
			Chirp.arr.add(API.avatarTemplate.exec({
				avatar: s.sender.profile_image_url,
				user: s.sender.screen_name,
				name: s.sender.name,
				name_link: ' title="' + API.fans(s.sender.followers_count) + '"',
				url: API.URL("profile", s.sender.screen_name),
				post: API.links(s.text, Yes),
				link: ($p('service') == "0" ? Chirp.twitterAPI+'direct_messages' : 'http://identi.ca'),
				time: API.time(s.created_at),
				reply_link: ' <a onclick="API.setVal(\'' + s.sender.screen_name + '\')">' + 'reply' + '</a>'
			}));
			cjson.add(API.cjsonTemplate.exec({
				name: encodeURIComponent(s.sender.name),
				post: encodeURIComponent(s.text),
				time: s.created_at
			}));
		});
		var feed = Chirp.arr.join('');
		$$.inject('<table><tbody>' + feed + '</tbody></table>');
		$p("cache", '[' + cjson.toString() + ']');
		$$.scroll();
	}
};
//ERRORS
Chirp.timeError = "There was a 'timed out' error while connecting to " + Service.name() + ". This may either be a problem with the server or your Internet connection. Please check your network settings and verify that you can connect to the Internet, then try refreshing your " + Service.feed() + " again.";
Chirp.postError = 'Chirp encountered an error while posting your ' + Service.post() + '. This may either be a problem with the server or your Internet connection, so please verify that you can connect to the Internet and try again in a few minutes...';
Chirp.jsonError = Service.name() + ' returned a bad JSON response. This is most likely due to a problem with the server, but can also occur with certain proxy configurations. Please check your settings and verify that you can connect to the Internet, then try refreshing your ' + Service.feed() + ' again.';
Chirp.noInternet = "Chirp can't connect to " + Service.name() + " because your computer isn't connected to the Internet. Please verify that you can connect to the Internet and try refreshing your " + Service.feed() + " again.";
Chirp.failure = "Chirp encountered an error while loading your " + Service.feed() + ". This may either be a problem with the server or your Internet connection, so please verify that you can connect to the Internet and try again in a few minutes...";